&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------

  File:                calendar.w

  Description:         Non-modal multi-lingual calendar.

  Input Parameters:
                       Parameter line

  Output Parameters:
      <none>

  Author:               Marcel FONDACCI
                        m.fondacci@4gl.fr

  Created:              1999-2000


  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

Define
&IF DEFINED(UIB_IS_RUNNING) = 0 &then
        input parameter     
&else        
        var
&endif        
                    inputLine   as CHAR NO-UNDO
                    initial "date=02/10/2012|language=english|bgcolor=17|fgcolor=0|font=22"
                    .


DEF VAR     I               AS INT          NO-UNDO.
DEF VAR     B               AS HANDLE       EXTENT 42       NO-UNDO.    /* 6 weeks(max) x 7 days = 42 widgets */
DEF VAR     THE-FOCUS       AS HANDLE       NO-UNDO.



DEF VAR startingRow AS DECIMAL    NO-UNDO     INITIAL 4.          /* starting Row    */
DEF VAR startingCol AS DECIMAL    NO-UNDO     INITIAL 4.60.       /* starting col    */

DEF VAR W AS DECIMAL    NO-UNDO     INITIAL 8.40.       /* Standard width  */
DEF VAR H AS DECIMAL    NO-UNDO     INITIAL 1.48.       /* Standard heigth */

Def var deltaHeight     as          DECIMAL NO-UNDO initial 0.2.            /* Diff between lines and buttons */
Def var deltaWidth      as          DECIMAL NO-UNDO initial 0.6.

DEF VAR DELTA-J         as int      NO-UNDO.

def var oldHeight       as int      NO-UNDO.

/*_____________________________________________________________________________
          Set of parameters
  ____________________________________________________________________________*/          

/*      Evenements names
        ==============*/
        
&Scop onDateChanged         onDateChanged
&Scop onLeaveInfo           onLeaveInfo
        
Def var DayNames                as CHAR NO-UNDO.
Def var MonthNames              as CHAR NO-UNDO.
Def var WindowTitle             as Char NO-UNDO.
Def var CancelLabel             as char NO-UNDO.
Def var fontNumber              as Int  NO-UNDO initial ?.
Def var backColor               as int  NO-UNDO initial ?.
Def var frontColor              as int  NO-UNDO initial ?.
Def var enableInput             as logical NO-UNDO.
Def var enableDisplay           as logical NO-UNDO.
Def var startingDate            as date NO-UNDO initial TODAY.

Def var displayLanguage         as Char no-undo     initial "English".

Def var hProgramToRun           as Handle no-undo.
Def var currentDate             as date no-undo.


{ 4GLdate.i }


/* Local Variable Definitions ---                                       */

hProgramToRun = This-PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME CalendarFrame

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS bPrevMonth bNextMonth bClose Btn_OK ~
Btn_Cancel 
&Scoped-Define DISPLAYED-OBJECTS D-MOIS D-ANNEE J-1 J-2 J-3 J-4 J-5 J-6 J-7 ~
w4GL 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON bClose 
     IMAGE-UP FILE "4glclose":U
     LABEL "A" 
     SIZE 4 BY 1.14.

DEFINE BUTTON bNextMonth 
     IMAGE-UP FILE "4glmonthnext":U
     LABEL "nextMonth" 
     SIZE 4 BY 1.14.

DEFINE BUTTON bPrevMonth 
     IMAGE-UP FILE "4glmonthprev":U
     LABEL "Prev month" 
     SIZE 4 BY 1.14.

DEFINE BUTTON Btn_Cancel AUTO-END-KEY 
     LABEL "&Cancel" 
     SIZE 15 BY 1.14
     BGCOLOR 8 .

DEFINE BUTTON Btn_OK AUTO-GO 
     LABEL "&OK" 
     SIZE 15 BY 1.14
     BGCOLOR 8 .

DEFINE VARIABLE wDisplay AS CHARACTER 
     VIEW-AS EDITOR SCROLLBAR-VERTICAL
     SIZE 64 BY 1.91
     BGCOLOR 15  NO-UNDO.

DEFINE VARIABLE D-ANNEE AS INTEGER FORMAT ">>>>":U INITIAL 0 
     VIEW-AS FILL-IN 
     SIZE 17.4 BY 1.14
     BGCOLOR 1 FGCOLOR 11  NO-UNDO.

DEFINE VARIABLE D-MOIS AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 32.8 BY 1.14
     BGCOLOR 1 FGCOLOR 11  NO-UNDO.

DEFINE VARIABLE J-1 AS CHARACTER FORMAT "X(256)":U 
      VIEW-AS TEXT 
     SIZE 7.2 BY 1.1 NO-UNDO.

DEFINE VARIABLE J-2 AS CHARACTER FORMAT "X(256)":U 
      VIEW-AS TEXT 
     SIZE 7.2 BY 1.1 NO-UNDO.

DEFINE VARIABLE J-3 AS CHARACTER FORMAT "X(256)":U 
      VIEW-AS TEXT 
     SIZE 7.2 BY 1.1 NO-UNDO.

DEFINE VARIABLE J-4 AS CHARACTER FORMAT "X(256)":U 
      VIEW-AS TEXT 
     SIZE 7.2 BY 1.1 NO-UNDO.

DEFINE VARIABLE J-5 AS CHARACTER FORMAT "X(256)":U 
      VIEW-AS TEXT 
     SIZE 7.2 BY 1.1 NO-UNDO.

DEFINE VARIABLE J-6 AS CHARACTER FORMAT "X(256)":U 
      VIEW-AS TEXT 
     SIZE 7.2 BY 1.1 NO-UNDO.

DEFINE VARIABLE J-7 AS CHARACTER FORMAT "X(256)":U 
      VIEW-AS TEXT 
     SIZE 7.2 BY 1.1 NO-UNDO.

DEFINE VARIABLE w4GL AS CHARACTER FORMAT "X(256)":U INITIAL "www.4gl.fr" 
      VIEW-AS TEXT 
     SIZE 31 BY 1.1 NO-UNDO.

DEFINE RECTANGLE RECT-AREA
     EDGE-PIXELS 0  NO-FILL 
     SIZE 60.8 BY 12.

DEFINE BUTTON bMax 
     IMAGE-UP FILE "4glopen":U
     LABEL "V" 
     SIZE 4 BY .95.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME CalendarFrame
     bPrevMonth AT ROW 1 COL 2
     D-MOIS AT ROW 1 COL 6.2 NO-LABEL
     D-ANNEE AT ROW 1 COL 39 NO-LABEL
     bNextMonth AT ROW 1 COL 56
     bClose AT ROW 1 COL 60
     wDisplay AT ROW 14.57 COL 1 NO-LABEL
     Btn_OK AT ROW 16.52 COL 34.2
     Btn_Cancel AT ROW 16.52 COL 49.4
     J-1 AT ROW 2.67 COL 2.8 NO-LABEL
     J-2 AT ROW 2.67 COL 9.4 COLON-ALIGNED NO-LABEL
     J-3 AT ROW 2.67 COL 18 COLON-ALIGNED NO-LABEL
     J-4 AT ROW 2.67 COL 26.6 COLON-ALIGNED NO-LABEL
     J-5 AT ROW 2.67 COL 35.2 COLON-ALIGNED NO-LABEL
     J-6 AT ROW 2.67 COL 43.8 COLON-ALIGNED NO-LABEL
     J-7 AT ROW 2.67 COL 52.4 COLON-ALIGNED NO-LABEL
     w4GL AT ROW 16.48 COL 2 NO-LABEL
     RECT-AREA AT ROW 2.52 COL 2
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 66.8 BY 17.52
         FONT 6.

DEFINE FRAME minFrame
     bMax AT ROW 1 COL 60
    WITH 1 DOWN KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 64 BY 1.1
         BGCOLOR 1 FONT 6.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "Cal"
         HEIGHT             = 16.81
         WIDTH              = 64.6
         MAX-HEIGHT         = 19.67
         MAX-WIDTH          = 80
         VIRTUAL-HEIGHT     = 19.67
         VIRTUAL-WIDTH      = 80
         RESIZE             = no
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.

&IF '{&WINDOW-SYSTEM}' NE 'TTY' &THEN
IF NOT C-Win:LOAD-ICON("prevw4gl":U) THEN
    MESSAGE "Unable to load icon: prevw4gl"
            VIEW-AS ALERT-BOX WARNING BUTTONS OK.
&ENDIF
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* REPARENT FRAME */
ASSIGN FRAME minFrame:FRAME = FRAME CalendarFrame:HANDLE.

/* SETTINGS FOR FRAME CalendarFrame
                                                                        */
/* SETTINGS FOR FILL-IN D-ANNEE IN FRAME CalendarFrame
   NO-ENABLE ALIGN-L                                                    */
/* SETTINGS FOR FILL-IN D-MOIS IN FRAME CalendarFrame
   NO-ENABLE ALIGN-L                                                    */
/* SETTINGS FOR FILL-IN J-1 IN FRAME CalendarFrame
   NO-ENABLE ALIGN-L                                                    */
/* SETTINGS FOR FILL-IN J-2 IN FRAME CalendarFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN J-3 IN FRAME CalendarFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN J-4 IN FRAME CalendarFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN J-5 IN FRAME CalendarFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN J-6 IN FRAME CalendarFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN J-7 IN FRAME CalendarFrame
   NO-ENABLE                                                            */
/* SETTINGS FOR RECTANGLE RECT-AREA IN FRAME CalendarFrame
   NO-ENABLE                                                            */
ASSIGN 
       RECT-AREA:HIDDEN IN FRAME CalendarFrame           = TRUE.

/* SETTINGS FOR FILL-IN w4GL IN FRAME CalendarFrame
   NO-ENABLE ALIGN-L                                                    */
/* SETTINGS FOR EDITOR wDisplay IN FRAME CalendarFrame
   NO-DISPLAY NO-ENABLE                                                 */
ASSIGN 
       wDisplay:HIDDEN IN FRAME CalendarFrame           = TRUE.

/* SETTINGS FOR FRAME minFrame
   NOT-VISIBLE                                                          */
ASSIGN 
       FRAME minFrame:HIDDEN           = TRUE.

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* Cal */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* Cal */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-MAXIMIZED OF C-Win /* Cal */
DO:
           

            Frame minFrame:Hidden = true.
            {&WINDOW-NAME}:Height-Pixels = OldHeight.
            Frame calendarFrame:Hidden = False.  

 {&WINDOW-NAME}:WINDOW-STATE = WINDOW-NORMAL.

            Frame minFrame:Hidden = true.
            {&WINDOW-NAME}:Height-Pixels = OldHeight.
            Frame calendarFrame:Hidden = False.                       
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-MINIMIZED OF C-Win /* Cal */
DO:
      
/*  {&WINDOW-NAME}:WINDOW-STATE = WINDOW-NORMAL.
 *   
 *   Frame calendarFrame:hidden = True.  
 *   Frame minFrame:Hidden      = False.
 *   
 *   view frame minFrame.
 *   
 *   {&WINDOW-NAME}:height-pixels = Frame minFrame:height-Pixels.*/
    
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bClose
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bClose C-Win
ON CHOOSE OF bClose IN FRAME CalendarFrame /* A */
DO:
  Frame calendarFrame:hidden = true.  
  Frame minFrame:Hidden = False.
  
  view frame minFrame.
  
  {&WINDOW-NAME}:height-pixels = Frame minFrame:height-Pixels.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME minFrame
&Scoped-define SELF-NAME bMax
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bMax C-Win
ON CHOOSE OF bMax IN FRAME minFrame /* V */
DO:
  Frame minFrame:Hidden = true.
  {&WINDOW-NAME}:Height-Pixels = OldHeight.
  Frame calendarFrame:Hidden = False.
  Run setDate(CurrentDate).
  Return NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define FRAME-NAME CalendarFrame
&Scoped-define SELF-NAME bNextMonth
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bNextMonth C-Win
ON CHOOSE OF bNextMonth IN FRAME CalendarFrame /* nextMonth */
DO:
  DEF VAR NEW-DATE          AS DATE NO-UNDO.
  
  NEW-DATE = DATE( INT(D-MOIS:PRIVATE-DATA), 1, D-ANNEE) + 35.
  NEW-DATE = NEW-DATE - DAY(NEW-DATE) + 1.
  
  RUN setDate(NEW-DATE).
  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bPrevMonth
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bPrevMonth C-Win
ON CHOOSE OF bPrevMonth IN FRAME CalendarFrame /* Prev month */
DO:
    DEF VAR NEW-DATE          AS DATE NO-UNDO.
  
  NEW-DATE = DATE( INT(D-MOIS:PRIVATE-DATA), 1, D-ANNEE) - 1.
  
  RUN setDate(NEW-DATE).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_Cancel
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Cancel C-Win
ON CHOOSE OF Btn_Cancel IN FRAME CalendarFrame /* Cancel */
DO:
  If valid-Handle( hProgramToRun)
  And can-do( hProgramToRun:INTERNAL-ENTRIES, "calendarCancel") then
        Run "calendarCancel" in hProgramToRun
                    (This-Procedure,
                     currentDate,
                     wDisplay:Handle).

   else
        APPLY "CLOSE" to THIS-PROCEDURE.    /* DEFAULT ACTION */    
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_OK
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_OK C-Win
ON CHOOSE OF Btn_OK IN FRAME CalendarFrame /* OK */
DO:
  If valid-Handle( hProgramToRun)
  And can-do( hProgramToRun:INTERNAL-ENTRIES, "calendarOK") then
        Run "calendarOK" in hProgramToRun
                    (This-Procedure,
                     currentDate,
                     wDisplay:Handle).         

   else
        APPLY "CLOSE" to THIS-PROCEDURE.    /* DEFAULT ACTION */                     
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME wDisplay
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wDisplay C-Win
ON LEAVE OF wDisplay IN FRAME CalendarFrame
OR RETURN OF {&SELF-NAME} DO:
    If valid-handle(hProgramToRun)
    And can-do(hProgramToRun:INTERNAL-ENTRIES, "{&onLeaveINFO}") then
            RUN "{&onLeaveINFO}" in hProgramToRun
                        (THIS-PROCEDURE,
                         currentDate,
                         wDisplay:Handle in frame {&FRAME-NAME}).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */


RUN ScaleEvaluation.

RUN createButtons.              /* Create all buttons            */
RUN CalendarSetAttributes( inputLine ).       /* ...and examine the parameters */
  
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
           
  RUN enable_UI.
  
  Run setDate(currentDate).
  
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
                WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE AdjustScreen C-Win 
PROCEDURE AdjustScreen :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  /* set the frame values
     ==================*/
     
  ASSIGN Frame {&FRAME-NAME}:BGCOLOR = backColor  When Frame {&FRAME-NAME}:BGCOLOR <> backColor
         Frame {&FRAME-NAME}:FGCOLOR = frontColor When Frame {&FRAME-NAME}:FGCOLOR <> frontColor
         Frame {&FRAME-NAME}:FONT    = fontNumber When Frame {&FRAME-NAME}:FONT    <> fontNumber
               {&WINDOW-NAME}:title  = windowTitle.
  
  /* set the interface values
     =======================*/

   wDisplay:SENSITIVE =     VALID-HANDLE( hProgramtoRun )
                            AND can-do( hProgramtoRun:INTERNAL-ENTRIES, "{&onLeaveInfo}").
   
   enableDISPLAY = wDisplay:SENSITIVE
                   OR ( Valid-Handle(hProgramToRun)
                        and can-do( hProgramtoRun:INTERNAL-ENTRIES, "{&onDateChanged}")
                      ).
   
   wDisplay:HIDDEN    = NOT enableDisplay.
  
   If enableDisplay
   And not wDisplay:SENSITIVE then
                    ASSIGN wDisplay:SENSITIVE = TRUE
                           wDisplay:READ-ONLY = TRUE.
  else if wDisplay:SENSITIVE then
                    wDisplay:READ-ONLY = False.
                    
  { 4GLdate.i }
  
  RUN setDayLabels.   
  Disp J-1 J-2 J-3 J-4 J-5 J-6 J-7 with frame calendarFrame.
                     
  Run setDate( startingDate ).

  Btn_Cancel:Label = cancelLabel.
                          
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE CalendarSetAttributes C-Win 
PROCEDURE CalendarSetAttributes :
/*------------------------------------------------------------------------------
  Purpose:     Analyze parameter line
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/
Def input parameter         L as char no-undo.

Def var   I                 as INT NO-UNDO.
Def var cellValue           as CHAR NO-UNDO.
Def var parmLabel           as CHAR NO-UNDO.
Def var parmValue           as CHAR NO-UNDO.

DO I = 1 to num-entries(L, "|") :
    cellValue = entry(I, L, "|").
    if CellValue = "" then NEXT.
    
    parmLabel = entry(1, CellValue, "=").
    parmValue = entry(2, CellValue, "=").
    
    if num-entries(cellValue, "=") = 1 then do :
            Message "Entry" I "of parameter line is incorrect :"
                    skip
                    cellValue
                    skip(1)
                    "(No value specified.)"
                    view-as alert-box ERROR.
            next.
            end.
     
     CASE parmLabel :
            When "BGCOLOR" then
                           backColor  = INT(parmValue) NO-ERROR.
            When "FGCOLOR" then
                           frontColor = INT(parmValue) NO-ERROR.
            When "FONT"    then
                           fontNumber = INT(parmValue) NO-ERROR.
            When "ProgramHandle" then
                           hProgramToRun  = Widget-Handle(parmValue) NO-ERROR.
/*            When "onValueChanged" then
 *                            onValueChanged = parmValue.
 *             When "onLeave" then
 *                            ASSIGN {&onLeaveInfo}    = parmValue
 *                                   enableDisplay  = TRUE.*/
            When "EnableDisplay" then
                           EnableDisplay = ParmValue = "yes".
            When "EnableInput" then
                           EnableInput = ParmValue = "yes".
            When "Daylabels" then
                           DayNames    = ParmValue.
            When "MonthLabels" then
                           MonthNames  = ParmValue.
            When "Title" then
                           WindowTitle = ParmValue.
            When "Cancel" then
                           cancelLabel = ParmValue.
            When "Language" then do :
                           displayLanguage = ParmValue.
                           { 4GLdate.i }
                           end.
            When "Date" then
                           startingDate = DATE( ParmValue ) no-error.
            end.
      END.
      
   Run adjustScreen.
                                                  


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE Choose C-Win 
PROCEDURE Choose :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
        currentDate =
                         DATE( INT(D-MOIS:PRIVATE-DATA in frame calendarFrame), 
                         INT(SELF:LABEL), 
                         Input frame calendarFrame D-ANNEE).
 
        RUN FOCUS-ON ( SELF ).
        
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createButtons C-Win 
PROCEDURE createButtons :
/*------------------------------------------------------------------------------
  Purpose:     Create the buttons widgets
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEF VAR R AS DECIMAL    NO-UNDO.
DEF VAR C AS DECIMAL    NO-UNDO.

  oldHeight = {&WINDOW-NAME}:Height-Pixels.
def var hR as handle no-undo.
  
  Frame calendarFrame:Hidden = true.
  C = startingCol.
  R = startingRow.
  
  DO I = 1 TO 7 :
            Create RECTANGLE hR
                ASSIGN
                       FRAME  = FRAME calendarFrame:HANDLE
                       WIDTH  = I * W  + 0.20
                       HEIGHT = 7 * H
                       HIDDEN = TRUE
                       ROW      = Rect-AREA:ROW
                       COLUMN = startingCol - 0.2
                       VISIBLE = TRUE
                       FILLED = FALSE
                       EDGE-PIXELS = 1.
            END.
  
  DO I = 1 to 6 :
          Create RECTANGLE hR
                ASSIGN
                       FRAME  = FRAME calendarFrame:HANDLE
                       WIDTH  = 7 * W + 0.5
                       HEIGHT = I * H
                       ROW      = Rect-AREA:ROW
                       COLUMN = startingCol - 0.2
                       HIDDEN = TRUE
                       VISIBLE = TRUE
                       FILLED = FALSE
                       EDGE-PIXELS = 1.
          END. 
             
  DO I = 1 to EXTENT(B) :
         CREATE BUTTON  B[I]
         ASSIGN
                FRAME  = FRAME calendarFrame:HANDLE
                WIDTH  = W  - deltaWidth
                HEIGHT = H  - deltaHeight
                HIDDEN = TRUE
                ROW    = R + deltaHeight / 2
                COLUMN = C + deltaWidth  / 2
                
         TRIGGERS :
            ON CHOOSE
                      PERSISTENT RUN Choose     in this-procedure.
            ON CURSOR-RIGHT, CURSOR-LEFT, CURSOR-UP, CURSOR-DOWN 
                      PERSISTENT RUN cursorMove in this-procedure.          
            END TRIGGERS.
         
         B[I]:PRIVATE-DATA = STRING( B[I]:X ) + "," + STRING( B[I]:Y ).
         

            
         IF I MOD 7 = 0 then
                    ASSIGN R = R + H
                           C = startingCol.
         ELSE
                    C = C + W.
         END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE cursorMove C-Win 
PROCEDURE cursorMove :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

 DEF VAR NEW-DATE  AS DATE NO-UNDO.

                  
 CASE KEYFUNCTION(LASTKEY) :
       WHEN "CURSOR-RIGHT" then
                           DELTA-J = 1.
       WHEN "CURSOR-LEFT" then
                           DELTA-J = -1.
       WHEN "CURSOR-UP" then
                           DELTA-J = -7.
       WHEN "CURSOR-DOWN" then
                           DELTA-J = 7.
       END.
 
 currentDate = currentDate + Delta-J.
 
 Run setDate( currentDate ).

 
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY D-MOIS D-ANNEE J-1 J-2 J-3 J-4 J-5 J-6 J-7 w4GL 
      WITH FRAME CalendarFrame IN WINDOW C-Win.
  ENABLE bPrevMonth bNextMonth bClose Btn_OK Btn_Cancel 
      WITH FRAME CalendarFrame IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-CalendarFrame}
  ENABLE bMax 
      WITH FRAME minFrame IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-minFrame}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE endCalendar C-Win 
PROCEDURE endCalendar :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
        Apply "CLOSE" to THIS-PROCEDURE.
        
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE Focus-On C-Win 
PROCEDURE Focus-On :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEF INPUT PARAMETER     H-B       as HANDLE       NO-UNDO.

    IF H-B = THE-FOCUS THEN do :
            h-B:Move-To-Top().
            APPLY "ENTRY":U TO H-B.
            RETURN.
            end.
    
    IF VALID-HANDLE(THE-FOCUS) then
                   ASSIGN THE-FOCUS:WIDTH  = W - DeltaWidth
                          THE-FOCUS:HEIGHT = H - DeltaHeight
                          THE-FOCUS:X     = INT( ENTRY(1, THE-FOCUS:PRIVATE-DATA) )
                          THE-FOCUS:Y     = INT( ENTRY(2, THE-FOCUS:PRIVATE-DATA) ).

    THE-FOCUS = H-B.
    ASSIGN      H-B:WIDTH  = H-B:WIDTH  + 2
                H-B:HEIGHT = H-B:HEIGHT + 0.5
                H-B:ROW    = H-B:ROW    - .25
                H-B:COLUMN = H-B:COLUMN - 1.

    H-B:MOVE-TO-TOP().

    APPLY "ENTRY":U TO H-B.
    
    If valid-handle(hProgramToRun)
    And can-do(hProgramToRun:INTERNAL-ENTRIES, "{&onDateChanged}") then
            RUN "{&onDateChanged}" in hProgramToRun
                        (THIS-PROCEDURE,
                         currentDate,
                         wDisplay:Handle in frame {&FRAME-NAME}).
                                      
        
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE Maximize C-Win 
PROCEDURE Maximize :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    Apply "Choose" to bMax in frame MinFrame.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE Minimize C-Win 
PROCEDURE Minimize :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    Apply "Choose" to bClose in frame calendarFrame.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE nextMonth C-Win 
PROCEDURE nextMonth :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    Apply "Choose" to bNextMonth in frame calendarFrame.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE prevMonth C-Win 
PROCEDURE prevMonth :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    Apply "Choose" to bPrevMonth in frame calendarFrame.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ScaleEvaluation C-Win 
PROCEDURE ScaleEvaluation :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/


DO WITH FRAME {&FRAME-NAME}  :

            W = RECT-AREA:WIDTH  / 7.
            H = RECT-AREA:HEIGHT / 7.
            
            W = TRUNCATE(W, 2).
            H = TRUNCATE(H, 2).
            
            StartingRow = RECT-AREA:ROW + H.
            startingCol = RECT-AREA:COL.
            END.

                    
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setDate C-Win 
PROCEDURE setDate :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEF INPUT PARAMETER         I-DATE      AS DATE NO-UNDO.


currentDate = I-Date.

DEF VAR                     F-DATE      AS DATE NO-UNDO.
DEF VAR                     Jour        as INT  NO-UNDO.

If D-Mois <> ENTRY( MONTH( I-DATE ), monthNames) then
        ASSIGN  D-MOIS                                     = ENTRY( MONTH( I-DATE ), monthNames)
                D-MOIS:SCREEN-VALUE IN FRAME {&FRAME-NAME} = D-MOIS
                D-MOIS:PRIVATE-DATA IN FRAME {&FRAME-NAME} = STRING(MONTH( I-DATE )).

If D-ANNEE <> YEAR( I-DATE ) then                
        ASSIGN  
                D-ANNEE = YEAR( I-DATE )
                D-ANNEE:SCREEN-VALUE = STRING(D-ANNEE).
        
F-DATE = DATE(MONTH(I-DATE), 1, YEAR(I-DATE)).
JOUR   = WEEKDAY( F-DATE ) - 2.
IF JOUR = -1 then
            JOUR = 6.  
                      
F-DATE = F-DATE - JOUR.

DO I = 1 TO EXTENT(B) :
            IF MONTH(F-DATE) = MONTH(I-DATE) THEN  DO : /* Same month */
                    ASSIGN      B[I]:LABEL = STRING( DAY(F-DATE) )
                                B[I]:HIDDEN = FALSE
                                B[I]:SENSITIVE = TRUE.
                    IF F-DATE = I-DATE then
                                RUN FOCUS-ON( B[I] ).                     
                    END.
            ELSE
                    ASSIGN      
                                B[I]:HIDDEN = TRUE.
            F-DATE = F-DATE + 1.
            END.                      


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setDayLabels C-Win 
PROCEDURE setDayLabels :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  J-7 = substring(entry(1, DayNames), 1, 3).
  J-1 = substring(entry(2, DayNames), 1, 3).
  J-2 = substring(entry(3, DayNames), 1, 3).
  J-3 = substring(entry(4, DayNames), 1, 3).
  J-4 = substring(entry(5, DayNames), 1, 3).
  J-5 = substring(entry(6, DayNames), 1, 3).
  J-6 = substring(entry(7, DayNames), 1, 3).
  
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE wonDateChanged C-Win 
PROCEDURE wonDateChanged :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
def input param h as handle.
def input param d as date.
def input param hh as handle.
message d view-as alert-box.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

